<?php
/*
 * SOY CMS パッケージ展開スクリプト
 *
 * @create 2008-10-09
 * @update 2008-10-09 14:45
 * @author nonaka
 *
 * 同階層に存在するSOY CMSのパッケージを展開する。
 *
 */
	$currentDir = str_replace("\\","/",dirname(__FILE__));

	$files = scandir($currentDir);

	$targets = array();

	$currentUrl = str_replace($_SERVER["DOCUMENT_ROOT"],"",$currentDir);
	if(substr($currentUrl,-1) != "/") $currentUrl.= "/";

	foreach($files as $file){
		if($file[0] == ".") continue;
		if(is_dir($currentDir."/".$file)) continue;

		if(preg_match("/^soycms_/i",$file)){
			$target = array(
				"pathname" => "",
				"filename" =>  "",
				"installer" => false,
				"version"=> null,
				"dbtype"=> null,
				"coding" => null
			);

			$tmp = explode("_",$file);

			if($tmp[1] == "install"){
				$target["pathname"] = realpath($currentDir."/".$file);
				$target["filename"] = $file;
				$target["installer"] = true;
				$target["version"] = $tmp[2];

				$tmp2 = explode(".",$tmp[3]);

				$target["dbtype"] = $tmp2[0];
				if($tmp2[1] == "zip"){
					$target["coding"] = "zip";
				}else{
					$target["coding"] = "tar.gz";
				}
			}else{
				$target["pathname"] = realpath($currentDir."/".$file);
				$target["filename"] = $file;
				$target["installer"] = false;
				$target["version"] = $tmp[1];

				$tmp2 = explode(".",$tmp[2]);

				$target["dbtype"] = $tmp2[0];
				if($tmp2[1] == "zip"){
					$target["coding"] = "zip";
				}else{
					$target["coding"] = "tar.gz";
				}
			}

			$targets[$target["filename"]] = $target;
		}
	}

	if(!isset($_GET["target_file"])){


		$overwritedir = array(true=>array(),false=>array());

		foreach(array("soycms_installer") as $dir){
			if(file_exists($currentDir."/".$dir)){
				$overwritedir[true][] = $dir;
			}
		}
		foreach(array("admin","soycms","common","license","app") as $dir){
			if(file_exists($currentDir."/".$dir)){
				$overwritedir[false][] = $dir;
			}
		}


		?>

		<h2>SOY CMSパッケージ解凍ツール</h2>
		<p>以下のファイルが検出されました。解凍したいファイルを選択して解凍ボタンを押してください。</p>
		<form  method="get">
			<select name="target_file" id="targets">
			<?php
				foreach($targets as $target){
					echo '<option value="'.$target["filename"].'">'.$target["filename"].'</option>';
				}
			?>
			</select>
			<script type="text/javascript">
				window.onload = function(){
					 document.getElementById("targets").onchange = function(){
						var op = this.options[this.selectedIndex];
						if(op.value.indexOf("install") != -1){
							document.getElementById("notice_installer").style.display = "";
							document.getElementById("notice_plain").style.display = "none";
						}else{
							document.getElementById("notice_installer").style.display = "none";
							document.getElementById("notice_plain").style.display = "";
						}
					 }

					 document.getElementById("targets").onchange();
				}

			</script>
			<noscript>
				<div style="color:red;" id="notice_installer" ><?php if(count($overwritedir[true]) != 0){ ?>
					<p>※以下のディレクトリがすでに存在します。続行するとこれらのディレクトリは上書きされます。</p>
					<p style="padding-left:20px"><?php echo implode(",",$overwritedir[true]);?></p><?php } ?>
				</div>

				<div style="color:red;" id="notice_plain"><?php if(count($overwritedir[false]) != 0){  ?>
					<p>※以下のディレクトリがすでに存在します。続行するとこれらのディレクトリは上書きされます。</p>
					<p style="padding-left:20px""><?php echo implode(",",$overwritedir[false]);?></p><?php } ?>
				</div>

			</noscript>
			<div style="color:red;display:none" id="notice_installer" ><?php if(count($overwritedir[true]) != 0){ ?>
				<p>※以下のディレクトリがすでに存在します。続行するとこれらのディレクトリは上書きされます。</p>
				<p style="padding-left:20px"><?php echo implode(",",$overwritedir[true]);?></p><?php } ?>
			</div>

			<div style="color:red;display:none" id="notice_plain"><?php if(count($overwritedir[false]) != 0){  ?>
				<p>※以下のディレクトリがすでに存在します。続行するとこれらのディレクトリは上書きされます。</p>
				<p style="padding-left:20px""><?php echo implode(",",$overwritedir[false]);?></p><?php } ?>
			</div>



			<?php if(!is_writable($currentDir)){ ?>
			<div style="color:red;display:none">
				<p>現在のディレクトリ(<?php echo $currentDir ;?>)に書き込み権限がありません。</p>
			</div>

			<?php } ?>
			<input type="submit" value="解凍">
		</form>
		<?php

		exit;
	}else{

		if(!isset($targets[$_GET["target_file"]])){
			header("Location: ".$_SERVER["PHP_SELF"]);
		}

		$target = $targets[$_GET["target_file"]];

		echo "SOYCMS バージョン".$target["version"]."　".$target["dbtype"]."版のパッケージを解凍しています<br>";

		if(!file_exists($target["filename"])){
			echo "SOYCMSファイルが見つかりませんでした。";
			exit;
		}

		if((bool)ini_get( "safe_mode" )){
			echo "safemode下ではこのスクリプトは使用できません";
			exit;
		}

		if(!is_writable($currentDir)){
			echo "現在のディレクトリに書き込み権限がありません。";
			exit;
		}



		exec("cd ".$currentDir);

		if($target["coding"] == "zip"){
			exec("unzip ".$target["filename"],$string);
		}else{
			exec("tar xfz ".$target["filename"],$string);
		}



		if($target["installer"]){
			if(!file_exists($currentDir."/soycms_installer")){
				echo "SOYCMSの解凍に失敗しました。<br>unzip,tarコマンドが使用可能であるか確認してください。";
				exit;
			}
		}else{
			if(!file_exists($currentDir."/soycms") || !file_exists($currentDir."/admin") || !file_exists($currentDir."/common")){
				echo "SOYCMSの解凍に失敗しました。<br>unzip,tarコマンドが使用可能であるか確認してください。";
				exit;
			}
		}

		echo "SOYCMSパッケージの解凍を行いました。<br>";

		if(!$target["installer"]){
			try{
				setWritable($currentDir."/admin/cache");
			}catch(Exception $e){
				echo $e->getMessage();
			}
			try{
				setWritable($currentDir."/soycms/cache");
			}catch(Exception $e){
				echo $e->getMessage();
			}
			try{
				setWritable($currentDir."/app/cache");
			}catch(Exception $e){
				echo $e->getMessage();
			}
			try{
				setWritable($currentDir."/common/db");
			}catch(Exception $e){
				echo $e->getMessage();
			}
		}else{
			try{
				setWritable($currentDir."/soycms_installer/log");
			}catch(Exception $e){
				echo $e->getMessage();
			}
		}

		echo "パッケージの展開は全て終了しました<br>";

		if($target["installer"]){
			echo '<a href="'.$currentUrl.'soycms_installer'.'">インストーラへ</a>';
		}else{
			echo '<a href="'.$currentUrl.'admin'.'">管理者ページへ</a>';
		}
	}


	function setWritable($dirname){
		if(file_exists($dirname)){
			@mkdir($dirname);
		}
		if(!is_writable($dirname)){
			@chmod($dirname,0777);
		}
		if(!is_writable($dirname)){
			throw new Exception($dirname."に書き込み権限を与えることができませんでした<br>");
		}
	}

?>